/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Diff of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.159 Revision 1.247
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.159 2006/02/17 22:18:20 swegener Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.247 2011/03/19 18:15:34 ssuominen Exp $
4 4
5# Description: kernel.eclass rewrite for a clean base regarding the 2.6 5# Description: kernel.eclass rewrite for a clean base regarding the 2.6
6# series of kernel with back-compatibility for 2.4 6# series of kernel with back-compatibility for 2.4
7# 7#
8# Maintainer: John Mylchreest <johnm@gentoo.org> 8# Original author: John Mylchreest <johnm@gentoo.org>
9# Maintainer: kernel-misc@gentoo.org
9# 10#
10# Please direct your bugs to the current eclass maintainer :) 11# Please direct your bugs to the current eclass maintainer :)
11 12
12# added functionality: 13# added functionality:
13# unipatch - a flexible, singular method to extract, add and remove patches. 14# unipatch - a flexible, singular method to extract, add and remove patches.
21# EXTRAVERSION would be something like : -wolk-4.19-r1 22# EXTRAVERSION would be something like : -wolk-4.19-r1
22# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be 23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
23# automatically set within the kernel Makefile 24# automatically set within the kernel Makefile
24# K_NOUSENAME - if this is set then EXTRAVERSION will not include the 25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the
25# first part of ${PN} in EXTRAVERSION 26# first part of ${PN} in EXTRAVERSION
27# K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28# anything based on ${PR}.
26# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources, 29# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
27# ck-sources, ac-sources) it will use PR (ie: -r5) as 30# ck-sources, ac-sources) it will use PR (ie: -r5) as
28# the patchset version for 31# the patchset version for
29# and not use it as a true package revision 32# and not use it as a true package revision
30# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in 33# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
31# postinst and can be used to carry additional postinst 34# postinst and can be used to carry additional postinst
32# messages 35# messages
36# K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
33# K_EXTRAEWARN - same as K_EXTRAEINFO except ewarn's instead of einfo's 37# K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
34# K_SYMLINK - if this is set, then forcably create symlink anyway 38# K_SYMLINK - if this is set, then forcably create symlink anyway
35# 39#
36# K_DEFCONFIG - Allow specifying a different defconfig target. 40# K_DEFCONFIG - Allow specifying a different defconfig target.
37# If length zero, defaults to "defconfig". 41# If length zero, defaults to "defconfig".
38# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any 42# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
39# combination of "base" and "extras" 43# combination of "base" and "extras"
40# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply. 44# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
41# A value of "5" would apply genpatches-2.6.12-5 to 45# A value of "5" would apply genpatches-2.6.12-5 to
42# my-sources-2.6.12.ebuild 46# my-sources-2.6.12.ebuild
43 47# K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
48# K_DEBLOB_AVAILABLE - A value of "0" will disable all of the optional deblob
49# code. If empty, will be set to "1" if deblobbing is
50# possible. Test ONLY for "1".
51# K_PREDEBLOBBED - This kernel was already deblobbed elsewhere.
52# If false, either optional deblobbing will be available
53# or the license will note the inclusion of freedist
54# code.
55# K_LONGTERM - If set, the eclass will search for the kernel source
56# in the long term directories on the upstream servers
57# as the location has been changed by upstream
44# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which 58# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
45# can be supported by the headers ebuild 59# can be supported by the headers ebuild
46 60
47# UNIPATCH_LIST - space delimetered list of patches to be applied to the 61# UNIPATCH_LIST - space delimetered list of patches to be applied to the
48# kernel 62# kernel
53# UNIPATCH_DOCS - space delimemeted list of docs to be installed to 67# UNIPATCH_DOCS - space delimemeted list of docs to be installed to
54# the doc dir 68# the doc dir
55# UNIPATCH_STRICTORDER - if this is set places patches into directories of 69# UNIPATCH_STRICTORDER - if this is set places patches into directories of
56# order, so they are applied in the order passed 70# order, so they are applied in the order passed
57 71
58inherit toolchain-funcs versionator multilib 72inherit eutils toolchain-funcs versionator multilib
59EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install \ 73EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_preinst pkg_postinst
60 pkg_preinst pkg_postinst
61 74
62# Added by Daniel Ostrow <dostrow@gentoo.org> 75# Added by Daniel Ostrow <dostrow@gentoo.org>
63# This is an ugly hack to get around an issue with a 32-bit userland on ppc64. 76# This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
64# I will remove it when I come up with something more reasonable. 77# I will remove it when I come up with something more reasonable.
65[[ ${PROFILE_ARCH} == 'ppc64' ]] && CHOST='powerpc64-unknown-linux-gnu' 78[[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
66 79
67export CTARGET=${CTARGET:-${CHOST}} 80export CTARGET=${CTARGET:-${CHOST}}
68if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then 81if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
69 export CTARGET=${CATEGORY/cross-} 82 export CTARGET=${CATEGORY/cross-}
70fi 83fi
71 84
72HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/" 85HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
86[[ -z ${LICENSE} ]] && \
73LICENSE="GPL-2" 87 LICENSE="GPL-2"
88
89# This is the latest KV_PATCH of the deblob tool available from the
90# libre-sources upstream. If you bump this, you MUST regenerate the Manifests
91# for ALL kernel-2 consumer packages where deblob is available.
92[[ -z ${DEBLOB_MAX_VERSION} ]] && DEBLOB_MAX_VERSION=37
93
94# No need to run scanelf/strip on kernel sources/headers (bug #134453).
95RESTRICT="binchecks strip"
74 96
75# set LINUX_HOSTCFLAGS if not already set 97# set LINUX_HOSTCFLAGS if not already set
76[[ -z ${LINUX_HOSTCFLAGS} ]] && \ 98[[ -z ${LINUX_HOSTCFLAGS} ]] && \
77 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include" 99 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"
100
101# debugging functions
102#==============================================================
103# this function exists only to help debug kernel-2.eclass
104# if you are adding new functionality in, put a call to it
105# at the start of src_unpack, or during SRC_URI/dep generation.
106debug-print-kernel2-variables() {
107 for v in PVR CKV OKV KV KV_FULL KV_MAJOR KV_MINOR KV_PATCH RELEASETYPE \
108 RELEASE UNIPATCH_LIST_DEFAULT UNIPATCH_LIST_GENPATCHES \
109 UNIPATCH_LIST S KERNEL_URI ; do
110 debug-print "${v}: ${!v}"
111 done
112}
78 113
79#Eclass functions only from here onwards ... 114#Eclass functions only from here onwards ...
80#============================================================== 115#==============================================================
81handle_genpatches() { 116handle_genpatches() {
82 local tarball 117 local tarball
83 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return -1 118 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return 1
84 119
85 for i in ${K_WANT_GENPATCHES} ; do 120 for i in ${K_WANT_GENPATCHES} ; do
86 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.bz2" 121 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.bz2"
87 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}" 122 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}"
88 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}" 123 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}"
124 KV_EXTRA=${KV_EXTRA/[-_]*} 159 KV_EXTRA=${KV_EXTRA/[-_]*}
125 else 160 else
126 KV_PATCH=$(get_version_component_range 3- ${OKV}) 161 KV_PATCH=$(get_version_component_range 3- ${OKV})
127 fi 162 fi
128 KV_PATCH=${KV_PATCH/[-_]*} 163 KV_PATCH=${KV_PATCH/[-_]*}
164
165 local v n=0 missing
166 for v in CKV OKV KV_{MAJOR,MINOR,PATCH} ; do
167 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
168 done
169 [[ $n -eq 1 ]] && \
170 eerror "Missing variables: ${missing}" && \
171 die "Failed to extract kernel version (try explicit CKV in ebuild)!"
172 unset v n missing
129 173
130 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 174 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
175 [[ -n "${K_LONGTERM}" ]] &&
176 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
177
178 KERNEL_URI="${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
131 179
132 RELEASE=${CKV/${OKV}} 180 RELEASE=${CKV/${OKV}}
133 RELEASE=${RELEASE/_beta} 181 RELEASE=${RELEASE/_beta}
134 RELEASE=${RELEASE/_rc/-rc} 182 RELEASE=${RELEASE/_rc/-rc}
135 RELEASE=${RELEASE/_pre/-pre} 183 RELEASE=${RELEASE/_pre/-pre}
184 # We cannot trivally call kernel_is here, because it calls us to detect the
185 # version
136 kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git} 186 #kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
187 [ $(($KV_MAJOR * 1000 + $KV_MINOR)) -ge 2006 ] && RELEASE=${RELEASE/-pre/-git}
137 RELEASETYPE=${RELEASE//[0-9]} 188 RELEASETYPE=${RELEASE//[0-9]}
138 189
139 # Now we know that RELEASE is the -rc/-git 190 # Now we know that RELEASE is the -rc/-git
140 # and RELEASETYPE is the same but with its numerics stripped 191 # and RELEASETYPE is the same but with its numerics stripped
141 # we can work on better sorting EXTRAVERSION. 192 # we can work on better sorting EXTRAVERSION.
142 # first of all, we add the release 193 # first of all, we add the release
143 EXTRAVERSION="${RELEASE}" 194 EXTRAVERSION="${RELEASE}"
195 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
144 [[ -n ${KV_EXTRA} ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}" 196 [[ -n ${KV_EXTRA} ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
145 197
198 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
199 if [[ -n "${K_NOUSEPR}" ]]; then
200 # Don't add anything based on PR to EXTRAVERSION
201 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
146 if [[ -n ${K_PREPATCHED} ]]; then 202 elif [[ -n ${K_PREPATCHED} ]]; then
203 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
147 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}" 204 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
148 elif [[ "${ETYPE}" = "sources" ]]; then 205 elif [[ "${ETYPE}" = "sources" ]]; then
206 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
149 # For some sources we want to use the PV in the extra version 207 # For some sources we want to use the PV in the extra version
150 # This is because upstream releases with a completely different 208 # This is because upstream releases with a completely different
151 # versioning scheme. 209 # versioning scheme.
152 case ${PN/-*} in 210 case ${PN/-*} in
153 wolk) K_USEPV=1;; 211 wolk) K_USEPV=1;;
154 vserver) K_USEPV=1;; 212 vserver) K_USEPV=1;;
155 esac 213 esac
156 214
157 [[ -z ${K_NOUSENAME} ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}" 215 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
158 [[ -n ${K_USEPV} ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}" 216 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
159 [[ -n ${PR//r0} ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}" 217 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
160 fi 218 fi
219 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
161 220
162 # The only messing around which should actually effect this is for KV_EXTRA 221 # The only messing around which should actually effect this is for KV_EXTRA
163 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else 222 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
164 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION 223 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
165 if [[ -n ${KV_EXTRA} ]]; then 224 if [[ -n ${KV_EXTRA} ]]; then
166 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}" 225 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
167 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/patch-${CKV}.bz2 226 KERNEL_URI="${KERNEL_BASE_URI}/patch-${CKV}.bz2
168 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.tar.bz2" 227 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
169 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2" 228 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2"
170 fi 229 fi
171 230
172 # We need to set this using OKV, but we need to set it before we do any 231 # We need to set this using OKV, but we need to set it before we do any
173 # messing around with OKV based on RELEASETYPE 232 # messing around with OKV based on RELEASETYPE
183 # will pull: 242 # will pull:
184 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-git2.bz2 243 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-git2.bz2
185 244
186 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then 245 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
187 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))" 246 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
188 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${CKV//_/-}.bz2 247 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.bz2
189 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 248 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
190 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2" 249 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2"
191 fi 250 fi
192 251
193 if [[ ${RELEASETYPE} == -git ]]; then 252 if [[ ${RELEASETYPE} == -git ]]; then
194 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${OKV}${RELEASE}.bz2 253 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.bz2
195 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 254 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
196 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2" 255 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2"
197 fi 256 fi
198 257
199 if [[ ${RELEASETYPE} == -rc-git ]]; then 258 if [[ ${RELEASETYPE} == -rc-git ]]; then
200 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))" 259 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
201 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2 260 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
202 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 261 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2
203 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 262 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
263
204 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2" 264 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
205 fi 265 fi
206 266
267 debug-print-kernel2-variables
268
207 handle_genpatches 269 handle_genpatches
208} 270}
209 271
210kernel_is() { 272kernel_is() {
273 # ALL of these should be set before we can safely continue this function.
274 # some of the sources have in the past had only one set.
275 local v n=0
276 for v in OKV KV_{MAJOR,MINOR,PATCH} ; do [[ -z ${!v} ]] && n=1 ; done
211 [[ -z ${OKV} ]] && detect_version 277 [[ $n -eq 1 ]] && detect_version
278 unset v n
279
280 # Now we can continue
212 local operator test value x=0 y=0 z=0 281 local operator test value x=0 y=0 z=0
213 282
214 case ${1} in 283 case ${1} in
215 lt) operator="-lt"; shift;; 284 lt) operator="-lt"; shift;;
216 gt) operator="-gt"; shift;; 285 gt) operator="-gt"; shift;;
248} 317}
249 318
250# Capture the sources type and set DEPENDs 319# Capture the sources type and set DEPENDs
251if [[ ${ETYPE} == sources ]]; then 320if [[ ${ETYPE} == sources ]]; then
252 DEPEND="!build? ( sys-apps/sed 321 DEPEND="!build? ( sys-apps/sed
253 >=sys-devel/binutils-2.11.90.0.31 ) 322 >=sys-devel/binutils-2.11.90.0.31 )"
254 doc? ( app-text/docbook-sgml-utils
255 app-text/xmlto )"
256 RDEPEND="!build? ( >=sys-libs/ncurses-5.2 323 RDEPEND="!build? ( >=sys-libs/ncurses-5.2
257 sys-devel/make ) 324 sys-devel/make )"
258 virtual/dev-manager" 325 PDEPEND="!build? ( virtual/dev-manager )"
259 326
260 PROVIDE="virtual/linux-sources" 327 PROVIDE="virtual/linux-sources"
261 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa"
262 328
263 SLOT="${PVR}" 329 SLOT="${PVR}"
264 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR} linux kernel" 330 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR} linux kernel"
265 IUSE="symlink build doc" 331 IUSE="symlink build"
332
333 # Bug #266157, deblob for libre support
334 if [[ -z ${K_PREDEBLOBBED} ]] ; then
335 if [[ -z ${K_DEBLOB_AVAILABLE} ]] ; then
336 kernel_is ge 2 6 27 && \
337 kernel_is le 2 6 ${DEBLOB_MAX_VERSION} && \
338 K_DEBLOB_AVAILABLE=1
339 fi
340 if [[ ${K_DEBLOB_AVAILABLE} == "1" ]] ; then
341 IUSE="${IUSE} deblob"
342 # Reflect that kernels contain firmware blobs unless otherwise
343 # stripped
344 LICENSE="${LICENSE} !deblob? ( freedist )"
345
346 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
347 DEBLOB_A="deblob-${DEBLOB_PV}"
348 DEBLOB_CHECK_A="deblob-check-${DEBLOB_PV}"
349 DEBLOB_HOMEPAGE="http://www.fsfla.org/svnwiki/selibre/linux-libre/"
350 DEBLOB_URI_PATH="download/releases/LATEST-${DEBLOB_PV}.N"
351 if ! has "${EAPI:-0}" 0 1 ; then
352 DEBLOB_CHECK_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/deblob-check -> ${DEBLOB_CHECK_A}"
353 else
354 DEBLOB_CHECK_URI="mirror://gentoo/${DEBLOB_CHECK_A}"
355 fi
356 DEBLOB_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/${DEBLOB_A}"
357 HOMEPAGE="${HOMEPAGE} ${DEBLOB_HOMEPAGE}"
358
359 KERNEL_URI="${KERNEL_URI}
360 deblob? (
361 ${DEBLOB_URI}
362 ${DEBLOB_CHECK_URI}
363 )"
364 else
365 # We have no way to deblob older kernels, so just mark them as
366 # tainted with non-libre materials.
367 LICENSE="${LICENSE} freedist"
368 fi
369 fi
370
266elif [[ ${ETYPE} == headers ]]; then 371elif [[ ${ETYPE} == headers ]]; then
267 DESCRIPTION="Linux system headers" 372 DESCRIPTION="Linux system headers"
268 IUSE="" 373
374 # Since we should NOT honour KBUILD_OUTPUT in headers
375 # lets unset it here.
376 unset KBUILD_OUTPUT
269 377
270 if [[ ${CTARGET} = ${CHOST} ]]; then 378 if [[ ${CTARGET} = ${CHOST} ]]; then
271 DEPEND="!virtual/os-headers" 379 DEPEND="!virtual/os-headers"
272 PROVIDE="virtual/os-headers" 380 PROVIDE="virtual/os-headers"
273 SLOT="0" 381 SLOT="0"
282# Cross-compile support functions 390# Cross-compile support functions
283#============================================================== 391#==============================================================
284kernel_header_destdir() { 392kernel_header_destdir() {
285 [[ ${CTARGET} == ${CHOST} ]] \ 393 [[ ${CTARGET} == ${CHOST} ]] \
286 && echo /usr/include \ 394 && echo /usr/include \
287 || echo /usr/${CTARGET}/include 395 || echo /usr/${CTARGET}/usr/include
288} 396}
289 397
290cross_pre_c_headers() { 398cross_pre_c_headers() {
291 [[ -z ${_E_CROSS_HEADERS_ONLY} ]] && return 1 399 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
292 [[ ${CHOST} == ${CTARGET} ]] && return 1
293 return 0
294} 400}
295 401
296env_setup_xmakeopts() { 402env_setup_xmakeopts() {
297 # Kernel ARCH != portage ARCH 403 # Kernel ARCH != portage ARCH
298 export KARCH=$(tc-arch-kernel) 404 export KARCH=$(tc-arch-kernel)
309} 415}
310 416
311# Unpack functions 417# Unpack functions
312#============================================================== 418#==============================================================
313unpack_2_4() { 419unpack_2_4() {
314 env_setup_xmakeopts
315
316 cd "${S}"
317 # this file is required for other things to build properly, 420 # this file is required for other things to build properly,
318 # so we autogenerate it 421 # so we autogenerate it
319 make -s mrproper ${xmakeopts} || die "make mrproper failed" 422 make -s mrproper ${xmakeopts} || die "make mrproper failed"
320 make -s symlinks ${xmakeopts} || die "make symlinks failed" 423 make -s symlinks ${xmakeopts} || die "make symlinks failed"
321 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed" 424 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
322 echo ">>> version.h compiled successfully." 425 echo ">>> version.h compiled successfully."
323} 426}
324 427
325unpack_2_6() { 428unpack_2_6() {
326 env_setup_xmakeopts
327
328 cd "${S}"
329 # this file is required for other things to build properly, so we 429 # this file is required for other things to build properly, so we
330 # autogenerate it ... touch .config to keep version.h build from 430 # autogenerate it ... generate a .config to keep version.h build from
331 # spitting out an annoying warning 431 # spitting out an annoying warning
332 make -s mrproper ${xmakeopts} || die "make mrproper failed" 432 make -s mrproper ${xmakeopts} 2>/dev/null \
433 || die "make mrproper failed"
434
435 # quick fix for bug #132152 which triggers when it cannot include linux
436 # headers (ie, we have not installed it yet)
437 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
333 touch .config 438 touch .config
334 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed" 439 eerror "make defconfig failed."
335 rm -f .config 440 eerror "assuming you dont have any headers installed yet and continuing"
441 epause 5
442 fi
443
444 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
445 || die "make include/linux/version.h failed"
446 rm -f .config >/dev/null
336} 447}
337 448
338universal_unpack() { 449universal_unpack() {
339 cd ${WORKDIR} 450 cd "${WORKDIR}"
340 unpack linux-${OKV}.tar.bz2 451 unpack linux-${OKV}.tar.bz2
452 if [[ -d "linux" ]]; then
453 mv linux linux-${KV_FULL} \
454 || die "Unable to move source tree to ${KV_FULL}."
341 if [[ "${OKV}" != "${KV_FULL}" ]]; then 455 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
342 mv linux-${OKV} linux-${KV_FULL} \ 456 mv linux-${OKV} linux-${KV_FULL} \
343 || die "Unable to move source tree to ${KV_FULL}." 457 || die "Unable to move source tree to ${KV_FULL}."
344 fi 458 fi
345 cd "${S}" 459 cd "${S}"
346 460
347 # remove all backup files 461 # remove all backup files
348 find . -iname "*~" -exec rm {} \; 2> /dev/null 462 find . -iname "*~" -exec rm {} \; 2> /dev/null
349 463
350 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox 464 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
351 use ppc && \ 465 # only do this for kernel < 2.6.27 since this file does not exist in later
466 # kernels
467 if [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]]
468 then
469 sed -i \
352 sed -ie 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \ 470 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
353 "${S}"/arch/ppc/Makefile 471 "${S}"/arch/ppc/Makefile
472 else
473 sed -i \
474 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
475 "${S}"/arch/powerpc/Makefile
476 fi
354} 477}
355 478
356unpack_set_extraversion() { 479unpack_set_extraversion() {
357 cd "${S}" 480 cd "${S}"
358 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile 481 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
359 cd ${OLDPWD} 482 cd "${OLDPWD}"
360} 483}
361 484
362# Should be done after patches have been applied 485# Should be done after patches have been applied
363# Otherwise patches that modify the same area of Makefile will fail 486# Otherwise patches that modify the same area of Makefile will fail
364unpack_fix_install_path() { 487unpack_fix_install_path() {
365 cd "${S}" 488 cd "${S}"
366 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile 489 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
367} 490}
368 491
369unpack_fix_docbook() {
370 if [[ -d ${S}/Documentation/DocBook ]]; then
371 cd "${S}"/Documentation/DocBook
372 sed -ie "s:db2:docbook2:g" Makefile
373 cd ${OLDPWD}
374 fi
375}
376
377# Compile Functions 492# Compile Functions
378#============================================================== 493#==============================================================
379compile_headers() { 494compile_headers() {
380 env_setup_xmakeopts 495 env_setup_xmakeopts
381
382 # Since KBUILD_OUTPUT shouldnt be used when compiling headers, lets unset it
383 # if it exists.
384 [[ -n ${KBUILD_OUTPUT} ]] && unset KBUILD_OUTPUT
385 496
386 # if we couldnt obtain HOSTCFLAGS from the Makefile, 497 # if we couldnt obtain HOSTCFLAGS from the Makefile,
387 # then set it to something sane 498 # then set it to something sane
388 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile) 499 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
389 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer} 500 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
391 if kernel_is 2 4; then 502 if kernel_is 2 4; then
392 yes "" | make oldconfig ${xmakeopts} 503 yes "" | make oldconfig ${xmakeopts}
393 echo ">>> make oldconfig complete" 504 echo ">>> make oldconfig complete"
394 make dep ${xmakeopts} 505 make dep ${xmakeopts}
395 elif kernel_is 2 6; then 506 elif kernel_is 2 6; then
507 # 2.6.18 introduces headers_install which means we dont need any
508 # of this crap anymore :D
509 kernel_is ge 2 6 18 && return 0
510
396 # autoconf.h isnt generated unless it already exists. plus, we have 511 # autoconf.h isnt generated unless it already exists. plus, we have
397 # no guarantee that any headers are installed on the system... 512 # no guarantee that any headers are installed on the system...
398 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \ 513 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
399 || touch include/linux/autoconf.h 514 || touch include/linux/autoconf.h
400 515
401 # if K_DEFCONFIG isn't set, force to "defconfig" 516 # if K_DEFCONFIG isn't set, force to "defconfig"
402 # needed by mips 517 # needed by mips
403 if [[ -z ${K_DEFCONFIG} ]]; then 518 if [[ -z ${K_DEFCONFIG} ]]; then
519 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
520 case ${CTARGET} in
521 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
522 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
523 *) K_DEFCONFIG="defconfig";;
524 esac
525 else
404 K_DEFCONFIG="defconfig" 526 K_DEFCONFIG="defconfig"
527 fi
405 fi 528 fi
406 529
407 # if there arent any installed headers, then there also isnt an asm 530 # if there arent any installed headers, then there also isnt an asm
408 # symlink in /usr/include/, and make defconfig will fail, so we have 531 # symlink in /usr/include/, and make defconfig will fail, so we have
409 # to force an include path with $S. 532 # to force an include path with $S.
410 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/" 533 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
411 ln -sf asm-${KARCH} "${S}"/include/asm 534 ln -sf asm-${KARCH} "${S}"/include/asm
412 cross_pre_c_headers && return 0 535 cross_pre_c_headers && return 0
413 536
414 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed" 537 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
538 if compile_headers_tweak_config ; then
539 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
540 fi
415 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed" 541 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
416 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed" 542 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
417 fi 543 fi
418} 544}
419 545
420compile_manpages() { 546compile_headers_tweak_config() {
421 einfo "Making manpages ..." 547 # some targets can be very very picky, so let's finesse the
422 env -u ARCH make mandocs 548 # .config based upon any info we may have
549 case ${CTARGET} in
550 sh*)
551 sed -i '/CONFIG_CPU_SH/d' .config
552 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
553 return 0;;
554 esac
555
556 # no changes, so lets do nothing
557 return 1
423} 558}
424 559
425# install functions 560# install functions
426#============================================================== 561#==============================================================
427install_universal() { 562install_universal() {
428 #fix silly permissions in tarball 563 #fix silly permissions in tarball
429 cd ${WORKDIR} 564 cd "${WORKDIR}"
430 chown -R root:root * 565 chown -R root:0 * >& /dev/null
431 chmod -R a+r-w+X,u+w * 566 chmod -R a+r-w+X,u+w *
432 cd ${OLDPWD} 567 cd ${OLDPWD}
433} 568}
434 569
435install_headers() { 570install_headers() {
436 local ddir=$(kernel_header_destdir) 571 local ddir=$(kernel_header_destdir)
437 572
438 cd "${S}" 573 # 2.6.18 introduces headers_install which means we dont need any
574 # of this crap anymore :D
575 if kernel_is ge 2 6 18 ; then
576 env_setup_xmakeopts
577 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
578
579 # let other packages install some of these headers
580 rm -rf "${D}"/${ddir}/sound #alsa-headers
581 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
582 return 0
583 fi
584
585 # Do not use "linux/*" as that can cause problems with very long
586 # $S values where the cmdline to cp is too long
587 pushd "${S}" >/dev/null
439 dodir ${ddir}/linux 588 dodir ${ddir}/linux
440 cp -ax "${S}"/include/linux/* ${D}/${ddir}/linux 589 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
441 rm -rf ${D}/${ddir}/linux/modules 590 rm -rf "${D}"/${ddir}/linux/modules
442 591
443 # Handle multilib headers and crap
444 local multi_dirs="" multi_defs=""
445 case $(tc-arch-kernel) in
446 sparc64)
447 multi_dirs="sparc sparc64"
448 multi_defs="!__arch64__ __arch64__"
449 ;;
450 x86_64)
451 multi_dirs="i386 x86_64"
452 multi_defs="__i386__ __x86_64__"
453 ;;
454 ppc64)
455 multi_dirs="ppc ppc64"
456 multi_defs="!__powerpc64__ __powerpc64__"
457 ;;
458 s390x)
459 multi_dirs="s390 s390x"
460 multi_defs="!__s390x__ __s390x__"
461 ;;
462 arm)
463 dodir ${ddir}/asm 592 dodir ${ddir}/asm
464 cp -ax "${S}"/include/asm/* "${D}"/${ddir}/asm 593 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
465 [[ ! -e ${D}/${ddir}/asm/arch ]] && ln -sf arch-ebsa285 "${D}"/${ddir}/asm/arch
466 [[ ! -e ${D}/${ddir}/asm/proc ]] && ln -sf proc-armv "${D}"/${ddir}/asm/proc
467 ;;
468 powerpc)
469 dodir ${ddir}/asm
470 cp -ax "${S}"/include/asm/* ${D}/${ddir}/asm
471 if [[ -e "${S}"/include/asm-ppc ]] ; then
472 dodir ${ddir}/asm-ppc
473 cp -ax "${S}"/include/asm-ppc/* ${D}/${ddir}/asm-ppc
474 fi
475 ;;
476 *)
477 dodir ${ddir}/asm
478 cp -ax "${S}"/include/asm/* ${D}/${ddir}/asm
479 ;;
480 esac
481 if [[ -n ${multi_dirs} ]] ; then
482 local d ml_inc=""
483 for d in ${multi_dirs} ; do
484 dodir ${ddir}/asm-${d}
485 cp -ax "${S}"/include/asm-${d}/* ${D}/${ddir}/asm-${d}/ || die "cp asm-${d} failed"
486 594
487 ml_inc="${ml_inc} ${multi_defs%% *}:${ddir}/asm-${d}"
488 multi_defs=${multi_defs#* }
489 done
490 create_ml_includes ${ddir}/asm ${ml_inc}
491 fi
492
493 if kernel_is 2 6; then 595 if kernel_is 2 6 ; then
494 dodir ${ddir}/asm-generic 596 dodir ${ddir}/asm-generic
495 cp -ax "${S}"/include/asm-generic/* ${D}/${ddir}/asm-generic 597 cp -pPR "${S}"/include/asm-generic/* "${D}"/${ddir}/asm-generic
496 fi 598 fi
497 599
498 # clean up 600 # clean up
499 find "${D}" -name '*.orig' -exec rm -f {} \; 601 find "${D}" -name '*.orig' -exec rm -f {} \;
500 602
501 cd ${OLDPWD} 603 popd >/dev/null
502} 604}
503 605
504install_sources() { 606install_sources() {
505 local doc docs file 607 local file
506 608
507 cd "${S}" 609 cd "${S}"
508 dodir /usr/src 610 dodir /usr/src
509 echo ">>> Copying sources ..." 611 echo ">>> Copying sources ..."
510 612
524 [[ -f ${FILESDIR}/../ChangeLog ]] && \ 626 [[ -f ${FILESDIR}/../ChangeLog ]] && \
525 echo "Please check the ebuild ChangeLog for more details." \ 627 echo "Please check the ebuild ChangeLog for more details." \
526 > "${S}"/patches.txt 628 > "${S}"/patches.txt
527 fi 629 fi
528 630
529 if use doc ; then
530 install_manpages
531
532 for doc in ${UNIPATCH_DOCS}; do [[ -f ${doc} ]] && docs="${docs} ${doc}"; done
533 if [[ -f ${S}/patches.txt ]]; then docs="${docs} ${S}/patches.txt"; fi
534 [[ -n ${docs} ]] && dodoc ${docs}
535 fi
536
537 mv ${WORKDIR}/linux* ${D}/usr/src 631 mv ${WORKDIR}/linux* "${D}"/usr/src
538}
539
540install_manpages() {
541 kernel_is lt 2 5 && return
542
543 local myfiles="Documentation/DocBook/Makefile"
544 kernel_is lt 2 6 12 && myfiles="scripts/makeman ${myfiles}"
545
546 sed -ie "s#/usr/local/man#${D}/usr/share/man#g" ${myfiles}
547 ebegin "Installing manpages"
548 env -u ARCH make installmandocs
549 eend $?
550 sed -ie "s#${D}/usr/share/man#/usr/local/man#g" ${myfiles}
551} 632}
552 633
553# pkg_preinst functions 634# pkg_preinst functions
554#============================================================== 635#==============================================================
555preinst_headers() { 636preinst_headers() {
564 local MAKELINK=0 645 local MAKELINK=0
565 646
566 # if we have USE=symlink, then force K_SYMLINK=1 647 # if we have USE=symlink, then force K_SYMLINK=1
567 use symlink && K_SYMLINK=1 648 use symlink && K_SYMLINK=1
568 649
650 # if we're using a deblobbed kernel, it's not supported
651 [[ $K_DEBLOB_AVAILABLE == 1 ]] && \
652 use deblob && \
653 K_SECURITY_UNSUPPORTED=deblob
654
569 # if we are to forcably symlink, delete it if it already exists first. 655 # if we are to forcably symlink, delete it if it already exists first.
570 if [[ -n ${K_SYMLINK} ]]; then 656 if [[ ${K_SYMLINK} > 0 ]]; then
571 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux 657 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
572 MAKELINK=1 658 MAKELINK=1
573 fi 659 fi
574 660
575 # if the link doesnt exist, lets create it 661 # if the link doesnt exist, lets create it
576 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1 662 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
577 663
578 if [[ ${MAKELINK} == 1 ]]; then 664 if [[ ${MAKELINK} == 1 ]]; then
579 cd ${ROOT}usr/src 665 cd "${ROOT}"usr/src
580 ln -sf linux-${KV_FULL} linux 666 ln -sf linux-${KV_FULL} linux
581 cd ${OLDPWD} 667 cd ${OLDPWD}
582 fi 668 fi
583 669
584 # Don't forget to make directory for sysfs 670 # Don't forget to make directory for sysfs
585 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys 671 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
586 672
587 echo 673 echo
588 einfo "After installing a new kernel of any version, it is important"
589 einfo "that you have the appropriate /etc/modules.autoload.d/kernel-X.Y"
590 einfo "created (X.Y is the first 2 parts of your new kernel version)"
591 echo
592 einfo "For example, this kernel will require:"
593 einfo "/etc/modules.autoload.d/kernel-${KV_MAJOR}.${KV_MINOR}"
594 echo
595 einfo "If you are upgrading from a previous kernel, you may be interested" 674 elog "If you are upgrading from a previous kernel, you may be interested"
596 einfo "in the following documents:" 675 elog "in the following document:"
597 einfo " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml" 676 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
598 kernel_is_2_6 && einfo " - 2.4 to 2.6 migration guide: http://www.gentoo.org/doc/en/migration-to-2.6.xml"
599 if kernel_is ge 2 6 13; then
600 ewarn "As of 2.6.13 the support for devfs has been removed."
601 ewarn "You will be required to either manage a static /dev"
602 ewarn "or to ensure that udev is starting on boot."
603 fi
604 echo 677 echo
605 678
606 # if K_EXTRAEINFO is set then lets display it now 679 # if K_EXTRAEINFO is set then lets display it now
607 if [[ -n ${K_EXTRAEINFO} ]]; then 680 if [[ -n ${K_EXTRAEINFO} ]]; then
608 echo ${K_EXTRAEINFO} | fmt | 681 echo ${K_EXTRAEINFO} | fmt |
609 while read -s ELINE; do einfo "${ELINE}"; done 682 while read -s ELINE; do einfo "${ELINE}"; done
610 fi 683 fi
611 684
685 # if K_EXTRAELOG is set then lets display it now
686 if [[ -n ${K_EXTRAELOG} ]]; then
687 echo ${K_EXTRAELOG} | fmt |
688 while read -s ELINE; do elog "${ELINE}"; done
689 fi
690
612 # if K_EXTRAEWARN is set then lets display it now 691 # if K_EXTRAEWARN is set then lets display it now
613 if [[ -n ${K_EXTRAEWARN} ]]; then 692 if [[ -n ${K_EXTRAEWARN} ]]; then
614 echo ${K_EXTRAEWARN} | fmt | 693 echo ${K_EXTRAEWARN} | fmt |
615 while read -s ELINE; do ewarn "${ELINE}"; done 694 while read -s ELINE; do ewarn "${ELINE}"; done
616 fi 695 fi
617}
618 696
619postinst_headers() { 697 # optionally display security unsupported message
620 einfo "Kernel headers are usually only used when recompiling glibc, as such, following the installation" 698 # Start with why
621 einfo "of newer headers, it is advised that you re-merge glibc as follows:" 699 if [[ ${K_SECURITY_UNSUPPORTED} = deblob ]]; then
622 einfo "emerge glibc" 700 ewarn "Deblobbed kernels are UNSUPPORTED by Gentoo Security."
623 einfo "Failure to do so will cause glibc to not make use of newer features present in the updated kernel" 701 elif [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
624 einfo "headers." 702 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
703 fi
704 # And now the general message.
705 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
706 ewarn "This means that it is likely to be vulnerable to recent security issues."
707 ewarn "For specific information on why this kernel is unsupported, please read:"
708 ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
709 fi
710
711 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
712 KV_MAJOR=$(get_version_component_range 1 ${OKV})
713 KV_MINOR=$(get_version_component_range 2 ${OKV})
714 KV_PATCH=$(get_version_component_range 3 ${OKV})
715 if [[ "$(tc-arch)" = "sparc" ]] \
716 && [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]]
717 then
718 echo
719 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
720 elog "you now need to do"
721 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
722 elog "instead of just"
723 elog " make"
724 elog "to compile the kernel. For more information please browse to"
725 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
726 echo
727 fi
625} 728}
626 729
627# pkg_setup functions 730# pkg_setup functions
628#============================================================== 731#==============================================================
629setup_headers() { 732setup_headers() {
655 758
656 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/" 759 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
657 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR} 760 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
658 761
659 # We're gonna need it when doing patches with a predefined patchlevel 762 # We're gonna need it when doing patches with a predefined patchlevel
660 shopt -s extglob 763 eshopts_push -s extglob
661 764
662 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers 765 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
663 # usage can be either via an env var or by params 766 # usage can be either via an env var or by params
664 # although due to the nature we pass this within this eclass 767 # although due to the nature we pass this within this eclass
665 # it shall be by param only. 768 # it shall be by param only.
666 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}" 769 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
667 UNIPATCH_LIST="${@}" 770 UNIPATCH_LIST="${@}"
668 771
669 #unpack any passed tarballs 772 #unpack any passed tarballs
670 for i in ${UNIPATCH_LIST}; do 773 for i in ${UNIPATCH_LIST}; do
671 if [ -n "$(echo ${i} | grep -e "\.tar" -e "\.tbz" -e "\.tgz")" ]; then 774 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
672 extention=${i/*./}
673 extention=${extention/:*/}
674 case ${extention} in
675 tbz2) PIPE_CMD="tar -xvjf";;
676 bz2) PIPE_CMD="tar -xvjf";;
677 tgz) PIPE_CMD="tar -xvzf";;
678 gz) PIPE_CMD="tar -xvzf";;
679 *) eerror "Unrecognized tarball compression"
680 die "Unrecognized tarball compression";;
681 esac
682
683 if [ -n "${UNIPATCH_STRICTORDER}" ]; then 775 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
684 unset z 776 unset z
685 STRICT_COUNT=$((10#${STRICT_COUNT} + 1)) 777 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
686 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++)); 778 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
687 do z="${z}0"; 779 do z="${z}0";
688 done 780 done
689 PATCH_ORDER="${z}${STRICT_COUNT}" 781 PATCH_ORDER="${z}${STRICT_COUNT}"
690 782
691 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/ 783 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
692 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR}/${PATCH_ORDER}/ 1>/dev/null 784 pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
785 unpack ${i##*/}
786 popd >/dev/null
693 else 787 else
694 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR} 1>/dev/null 788 pushd "${KPATCH_DIR}" >/dev/null
789 unpack ${i##*/}
790 popd >/dev/null
695 fi 791 fi
696 792
697 if [ $? == 0 ]; then
698 einfo "${i/*\//} unpacked"
699 [ -n "$(echo ${i} | grep ':')" ] && echo ">>> Strict patch levels not currently supported for tarballed patchsets" 793 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
700 else
701 eerror "Failed to unpack ${i/:*/}"
702 die "unable to unpack patch tarball"
703 fi
704 else 794 else
705 extention=${i/*./} 795 extention=${i/*./}
706 extention=${extention/:*/} 796 extention=${extention/:*/}
707 PIPE_CMD="" 797 PIPE_CMD=""
708 case ${extention} in 798 case ${extention} in
799 xz) PIPE_CMD="xz -dc";;
800 lzma) PIPE_CMD="lzma -dc";;
709 bz2) PIPE_CMD="bzip2 -dc";; 801 bz2) PIPE_CMD="bzip2 -dc";;
710 patch) PIPE_CMD="cat";; 802 patch) PIPE_CMD="cat";;
711 diff) PIPE_CMD="cat";; 803 diff) PIPE_CMD="cat";;
712 gz|Z|z) PIPE_CMD="gzip -dc";; 804 gz|Z|z) PIPE_CMD="gzip -dc";;
713 ZIP|zip) PIPE_CMD="unzip -p";; 805 ZIP|zip) PIPE_CMD="unzip -p";;
736 do z="${z}0"; 828 do z="${z}0";
737 done 829 done
738 PATCH_ORDER="${z}${STRICT_COUNT}" 830 PATCH_ORDER="${z}${STRICT_COUNT}"
739 831
740 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/ 832 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/
741 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL}) 833 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
742 else 834 else
743 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) 835 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
744 fi 836 fi
745 fi 837 fi
746 fi 838 fi
747 done 839 done
748 840
750 x=${KPATCH_DIR} 842 x=${KPATCH_DIR}
751 KPATCH_DIR="" 843 KPATCH_DIR=""
752 for i in $(find ${x} -type d | sort -n); do 844 for i in $(find ${x} -type d | sort -n); do
753 KPATCH_DIR="${KPATCH_DIR} ${i}" 845 KPATCH_DIR="${KPATCH_DIR} ${i}"
754 done 846 done
847
848 # do not apply fbcondecor patch to sparc/sparc64 as it breaks boot
849 # bug #272676
850 if [[ "$(tc-arch)" = "sparc" || "$(tc-arch)" = "sparc64" ]]; then
851 if [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.28 ]]; then
852 UNIPATCH_DROP="${UNIPATCH_DROP} *_fbcondecor-0.9.6.patch"
853 echo
854 ewarn "fbcondecor currently prevents sparc/sparc64 from booting"
855 ewarn "for kernel versions >= 2.6.29. Removing fbcondecor patch."
856 ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=272676 for details"
857 echo
858 fi
859 fi
755 860
756 #so now lets get rid of the patchno's we want to exclude 861 #so now lets get rid of the patchno's we want to exclude
757 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}" 862 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
758 for i in ${UNIPATCH_DROP}; do 863 for i in ${UNIPATCH_DROP}; do
759 ebegin "Excluding Patch #${i}" 864 ebegin "Excluding Patch #${i}"
773 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi 878 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
774 879
775 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)" 880 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)"
776 while [ ${PATCH_DEPTH} -lt 5 ]; do 881 while [ ${PATCH_DEPTH} -lt 5 ]; do
777 echo "Attempting Dry-run:" >> ${STDERR_T} 882 echo "Attempting Dry-run:" >> ${STDERR_T}
778 echo "cmd: patch -p${PATCH_DEPTH} --dry-run -f < ${i}" >> ${STDERR_T} 883 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
779 echo "=======================================================" >> ${STDERR_T} 884 echo "=======================================================" >> ${STDERR_T}
780 if [ $(patch -p${PATCH_DEPTH} --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then 885 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
781 echo "Attempting patch:" > ${STDERR_T} 886 echo "Attempting patch:" > ${STDERR_T}
782 echo "cmd: patch -p${PATCH_DEPTH} -f < ${i}" >> ${STDERR_T} 887 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
783 echo "=======================================================" >> ${STDERR_T} 888 echo "=======================================================" >> ${STDERR_T}
784 if [ $(patch -p${PATCH_DEPTH} -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then 889 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
785 eend 0 890 eend 0
786 rm ${STDERR_T} 891 rm ${STDERR_T}
787 break 892 break
788 else 893 else
789 eend 1 894 eend 1
790 eerror "Failed to apply patch ${i/*\//}" 895 eerror "Failed to apply patch ${i/*\//}"
791 eerror "Please attach ${STDERR_T} to any bug you may post." 896 eerror "Please attach ${STDERR_T} to any bug you may post."
897 eshopts_pop
792 die "Failed to apply ${i/*\//}" 898 die "Failed to apply ${i/*\//}"
793 fi 899 fi
794 else 900 else
795 PATCH_DEPTH=$((${PATCH_DEPTH} + 1)) 901 PATCH_DEPTH=$((${PATCH_DEPTH} + 1))
796 fi 902 fi
797 done 903 done
798 if [ ${PATCH_DEPTH} -eq 5 ]; then 904 if [ ${PATCH_DEPTH} -eq 5 ]; then
799 eend 1 905 eend 1
800 eerror "Please attach ${STDERR_T} to any bug you may post." 906 eerror "Please attach ${STDERR_T} to any bug you may post."
907 eshopts_pop
801 die "Unable to dry-run patch." 908 die "Unable to dry-run patch."
802 fi 909 fi
803 done 910 done
804 done 911 done
805 912
807 # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite, 914 # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite,
808 # which is why I'm not taking too much time over this. 915 # which is why I'm not taking too much time over this.
809 local tmp 916 local tmp
810 for i in ${UNIPATCH_DOCS}; do 917 for i in ${UNIPATCH_DOCS}; do
811 tmp="${tmp} ${i//*\/}" 918 tmp="${tmp} ${i//*\/}"
812 cp -f ${i} ${T}/ 919 cp -f ${i} "${T}"/
813 done 920 done
814 UNIPATCH_DOCS="${tmp}" 921 UNIPATCH_DOCS="${tmp}"
815 922
816 # clean up KPATCH_DIR's - fixes bug #53610 923 # clean up KPATCH_DIR's - fixes bug #53610
817 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done 924 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
818 925
819 LC_ALL="${myLC_ALL}" 926 LC_ALL="${myLC_ALL}"
820 LANG="${myLANG}" 927 LANG="${myLANG}"
928 eshopts_pop
821} 929}
822 930
823# getfilevar accepts 2 vars as follows: 931# getfilevar accepts 2 vars as follows:
824# getfilevar <VARIABLE> <CONFIGFILE> 932# getfilevar <VARIABLE> <CONFIGFILE>
825# pulled from linux-info 933# pulled from linux-info
937 return 0 1045 return 0
938} 1046}
939 1047
940headers___fix() { 1048headers___fix() {
941 # Voodoo to partially fix broken upstream headers. 1049 # Voodoo to partially fix broken upstream headers.
942 # Issues with this function should go to plasmaroo. 1050 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
943 sed -i \ 1051 sed -i \
944 -e "s/\([ "$'\t'"]\)\(u\|s\)\(8\|16\|32\|64\)\([ "$'\t'"]\)/\1__\2\3\4/g;" \ 1052 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
945 -e 's/ \(u\|s\)\(8\|16\|32\|64\)$/ __\1\2/g' \ 1053 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
946 -e 's/\([(, ]\)\(u\|s\)64\([, )]\)/\1__\264\3/g' \ 1054 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
947 -e "s/^\(u\|s\)\(8\|16\|32\|64\)\([ "$'\t'"]\)/__\1\2\3/g;" \ 1055 -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
948 -e "s/ inline / __inline__ /g" \ 1056 -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
949 "$@" 1057 "$@"
950} 1058}
951 1059
952# common functions 1060# common functions
953#============================================================== 1061#==============================================================
954kernel-2_src_unpack() { 1062kernel-2_src_unpack() {
955 universal_unpack 1063 universal_unpack
1064 debug-print "Doing unipatch"
956 1065
957 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \ 1066 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
958 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}" 1067 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
1068
1069 debug-print "Doing premake"
959 1070
960 # allow ebuilds to massage the source tree after patching but before 1071 # allow ebuilds to massage the source tree after patching but before
961 # we run misc `make` functions below 1072 # we run misc `make` functions below
962 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake 1073 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
963 1074
1075 debug-print "Doing epatch_user"
1076 epatch_user
1077
1078 debug-print "Doing unpack_set_extraversion"
1079
964 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion 1080 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
965 unpack_fix_docbook
966 unpack_fix_install_path 1081 unpack_fix_install_path
967 1082
1083 # Setup xmakeopts and cd into sourcetree.
1084 env_setup_xmakeopts
1085 cd "${S}"
1086
1087 # We dont need a version.h for anything other than headers
1088 # at least, I should hope we dont. If this causes problems
1089 # take out the if/fi block and inform me please.
1090 # unpack_2_6 should now be 2.6.17 safe anyways
1091 if [[ ${ETYPE} == headers ]]; then
968 kernel_is 2 4 && unpack_2_4 1092 kernel_is 2 4 && unpack_2_4
969 kernel_is 2 6 && unpack_2_6 1093 kernel_is 2 6 && unpack_2_6
1094 fi
1095
1096 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1097 cp "${DISTDIR}/${DEBLOB_A}" "${T}" || die "cp ${DEBLOB_A} failed"
1098 cp "${DISTDIR}/${DEBLOB_CHECK_A}" "${T}/deblob-check" || die "cp ${DEBLOB_CHECK_A} failed"
1099 chmod +x "${T}/${DEBLOB_A}" "${T}/deblob-check" || die "chmod deblob scripts failed"
1100 fi
970} 1101}
971 1102
972kernel-2_src_compile() { 1103kernel-2_src_compile() {
973 cd "${S}" 1104 cd "${S}"
974 [[ ${ETYPE} == headers ]] && compile_headers 1105 [[ ${ETYPE} == headers ]] && compile_headers
975 [[ ${ETYPE} == sources ]] && \ 1106
976 use doc && compile_manpages 1107 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1108 echo ">>> Running deblob script ..."
1109 sh "${T}/${DEBLOB_A}" --force || \
1110 die "Deblob script failed to run!!!"
1111 fi
977} 1112}
1113
1114# if you leave it to the default src_test, it will run make to
1115# find whether test/check targets are present; since "make test"
1116# actually produces a few support files, they are installed even
1117# though the package is binchecks-restricted.
1118#
1119# Avoid this altogether by making the function moot.
1120kernel-2_src_test() { :; }
978 1121
979kernel-2_pkg_preinst() { 1122kernel-2_pkg_preinst() {
980 [[ ${ETYPE} == headers ]] && preinst_headers 1123 [[ ${ETYPE} == headers ]] && preinst_headers
981} 1124}
982 1125
985 [[ ${ETYPE} == headers ]] && install_headers 1128 [[ ${ETYPE} == headers ]] && install_headers
986 [[ ${ETYPE} == sources ]] && install_sources 1129 [[ ${ETYPE} == sources ]] && install_sources
987} 1130}
988 1131
989kernel-2_pkg_postinst() { 1132kernel-2_pkg_postinst() {
990 [[ ${ETYPE} == headers ]] && postinst_headers
991 [[ ${ETYPE} == sources ]] && postinst_sources 1133 [[ ${ETYPE} == sources ]] && postinst_sources
992} 1134}
993 1135
994kernel-2_pkg_setup() { 1136kernel-2_pkg_setup() {
1137 if kernel_is 2 4; then
1138 if [ "$( gcc-major-version )" -eq "4" ] ; then
1139 echo
1140 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1141 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1142 ewarn "newer kernel that supports gcc-4."
1143 echo
1144 ewarn "Also be aware that bugreports about gcc-4 not working"
1145 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1146 echo
1147 epause 10
1148 fi
1149 fi
1150
1151 ABI="${KERNEL_ABI}"
995 [[ ${ETYPE} == headers ]] && setup_headers 1152 [[ ${ETYPE} == headers ]] && setup_headers
996 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..." 1153 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
997} 1154}

Legend:
Removed from v.1.159  
changed lines
  Added in v.1.247

  ViewVC Help
Powered by ViewVC 1.1.20